# Poodle 1.2.0

### *Guarding Your Files with a Byte*

A Custom Encryption Program

## License

Poodle © 2025 by Warren James is licensed under Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International. To view a copy of this license, visit [creativecommons.org/licenses/by-nc-sa/4.0](https://creativecommons.org/licenses/by-nc-sa/4.0/).

## Download

This program can be found at [thewarrenjames.com/Downloads/Poodle/Poodle.zip](https://thewarrenjames.com/Downloads/Poodle/Poodle.zip).

## How to Use the Program

Instead of running `poodle.exe` directly, you should run `poodle.bat`. This will open the terminal for you already in the `poodle.exe` directory and even print the help message shown below.  
It is recommended that you use `poodle.exe` through the terminal instead of through your file explorer because otherwise you will not be able to use any of the options listed below, including decryption.  
If you are new to using the terminal, don't worry. It isn't as complicated as it seems. There are also many online resources that can help.  
If you can't wrap your head around the idea of options, you are free to use the commands under Example Usage. They should cover almost everything you could ever use the program for.

## Help Page

To show the following help message, type `poodle.exe --help` in the terminal and press enter.  

```
usage: python poodle.py [-h] [-v] [-q] [-s] [-r] [-d] [-x] [-m [MODE]] [-p PASSWORD] [-S SEED] [-i INPUT [INPUT ...]] [-o OUTPUT]

A Custom Encryption Program

options:
  -h, --help            show this help message and exit
  -v, --debug           Enter debug mode
  -q, --quiet           Suppress all output except for errors
  -s, --silent          Suppress all output including errors
  -r, --recursive       Recursively encrypt the data in a given directory
  -d, --delete          Delete input file(s) or directory
  -x, --extract         Decrypt a poodle file
  -m [MODE], --mode [MODE]
                        Specify the rng used by poodle. 1: MT19337, uses a 32bit integer as the seed; 2: PCG64, uses a 64bit integer as the seed (more secure). Default is 1.
  -p PASSWORD, --password PASSWORD
                        Specify password used to poodle. Note, this use of this option is insecure. Only use if you are confident your command history is confidential.
  -S SEED, --seed SEED  Specify the hex seed used to poodle. Include leading zeros. If mode is 1, use a 32bit seed. If 2, a 64bit seed. Note, this use of this option is insecure. Only use if you are confident your command history is confidential.
  -i INPUT [INPUT ...], --input INPUT [INPUT ...]
                        Specify name of file(s) or directory to poodle
  -o OUTPUT, --output OUTPUT
                        Specify name to give the output poodle or the directory to extract the poodle to
```

## Example Usage

### Encrypting a Single File or Multiple Files

- Keep the original unencrypted file(s): `poodle.exe`
- Delete the original unencrypted file(s): `poodle.exe -d`

### Encrypting a Directory

- Keep the original unencrypted directory: `poodle.exe -r`
- Delete the original unencrypted directory: `poodle.exe -d -r`

### Decrypting a Poodle File

- Keep the poodle file after decryption: `poodle.exe -x`
- Delete the poodle file after decryption: `poodle.exe -d -x`

## How It Works

1. When you give Poodle a file, files, or a directory to encrypt, it compresses that data into a single .tar.gz file.  
2. Then, when you give Poodle a password, it passes it through the SHA-256 hash and XORs each byte with its corresponding byte in a resultant 32-bit integer.
    - Each byte is indexed from 0 to 255 and is XORed with the 32-bit integer's (hashByteIndex modulo 4) byte, with 0 mapping to the byte with bits 2^0 to 2^7, 1 mapping to the byte with bits 2^8 to 2^15, and so on.
3. Lastly, Poodle uses that 32-bit integer to seed a random byte generator. From which, it generates a nth random byte and XORs it with the the nth byte of the .tar.gz file.

As the method of encryption is symmetric, the reverse of the encryption process is used for decryption.

## Project Maintained By

### **Warren James**  
**📫 Contact me at thewarrenjames@gmail.com**  
**🌎 View my work at [thewarrenjames.com](https://thewarrenjames.com)**  
**❤️ Support me at [buymeacoffee.com/thewarrenjames](https://buymeacoffee.com/thewarrenjames)**